import java.io.*;

public abstract class Spieler {
  
  abstract void Aufforderung();

  abstract Spielzug zieht (Spielposition p);

  abstract void Endmeldung();
      
  } // Ende Spieler

class Mensch extends Spieler {
  // der menschliche Gegenspieler des Computers

  public void Aufforderung() 
    {System.out.println("Sie sind am Zug!");}

  public Spielzug zieht (Spielposition p) {
    Spielzug zug = new Spielzug(Eingabe(), p);
    while (! zug.zulssig()) {
      System.out.println("Ungueltiger Zug - neue Eingabe!");
      zug = new Spielzug(Eingabe(), p);
      } // Ende while
    return zug;
    } // Ende zieht

  private int Eingabe() {
    InputStreamReader lies = new InputStreamReader(System.in);
    BufferedReader    eing = new BufferedReader(lies);
    
    int anzahl = 0;
    try {
      System.out.print("Wie viele Hoelzchen nehmen Sie?(1..3)  ");
      anzahl = Integer.parseInt(eing.readLine());
      } // Ende try
    catch(IOException e){}
    return anzahl;
    } // Ende Eingabe

  public void Endmeldung()
    {System.out.println("\nGlueckwunsch - Sie haben gewonnen!");}

  } // Ende Mensch

class Person extends Mensch {

  private String name;

  public Person (String n)
    {name = n;}

  public void Aufforderung()
    {System.out.println(name + " ist am Zug!");}

  public void Endmeldung()
    {System.out.println(name + " hat gewonnen!");}

  } // Ende Person

class Computer extends Spieler {

  public void Aufforderung() 
    {System.out.print("Ich bin am Zug ");}

  public Spielzug zieht (Spielposition p) {
    Spielzug zug = Strategie(p);
    Zugmeldung(zug);
    return zug;
    } // Ende zieht

  private Spielzug Strategie (Spielposition p) {
    // ordnet jeder Spielposition einen Spielzug zu
    int k = Spielzug.maxEntnahmezahl;
    int rest = p.Hlzchenzahl() % (k + 1);
    if (rest == 0) {
      int zz = (int) Math.round((k - 1) * Math.random()) + 1;
      System.out.print(" * ");
      return new Spielzug(zz, p); // Verlegenheitszug
      } // Ende if
    else {
      if (Math.random() < 0.3) {
        int zz = (int) Math.round((k - 1) * Math.random()) + 1;
        System.out.print(" ** ");
        return new Spielzug(zz, p); // Fehlerzug
        } // Ende if
      else
        return new Spielzug(rest, p); // Gewinnzug
      } // Ende else
    } // Ende Strategie

  public void Zugmeldung (Spielzug z) {
    System.out.println("... und nehme " + 
                        z.Entnahmezahl() + " Hoelzchen!");
    } // Zugmeldung

  public void Endmeldung()
    {System.out.println("\nSie haben leider verloren.");}

  } // Ende Computer
