import java.io.*;

public abstract class Spiel {
  // Zweipersonen-Strategiespiel (im Textfenster)

  String        spielname, spielregeln;
  String        spielername1, spielername2;
  boolean       menschComputer;
  Spieler       anziehender, nachziehender, endziehender;
  Spielposition anfangsposition, endposition;

  InputStreamReader lies = new InputStreamReader(System.in);
  BufferedReader    eing = new BufferedReader(lies);

  protected Spiel (String s, String r)
    {spielname = s; spielregeln = r;}

  protected void Spielbeschreibung() {
    System.out.println("\nStrategiespiel " + spielname);
    System.out.println("\nSpielregeln:\n");
    System.out.println(spielregeln);
    } // Ende Spielbeschreibung

  protected void Vorbereitungen() {
    try {
      System.out.print("\nSoll ich Spielgegner sein ?(j/n) ");
      char Antwort = eing.readLine().toLowerCase().charAt(0);
      menschComputer = Antwort == 'j';
      if (! menschComputer) {  
        System.out.print("Name des ersten Spielers:  ");
        spielername1 = eing.readLine();
        System.out.print("Name des zweiten Spielers: ");
        spielername2 = eing.readLine();
        } // Ende if
      } // Ende try
    catch(IOException e){}
    } // Ende Vorbereitungen

  protected void Startangaben() {
    char ziffer = ' ';
    if (! menschComputer) {
      System.out.print("\nWer soll beginnen (1) " +
                          spielername1 + " oder (2) " +
                          spielername2 + "? ");
      try 
        {ziffer = eing.readLine().toLowerCase().charAt(0);}
      catch(IOException e){}
      if (ziffer == '1') {
        anziehender = new Person(spielername1); 
        nachziehender = new Person(spielername2);
        } // Ende if
      else {
        anziehender = new Person(spielername2);
        nachziehender = new Person(spielername1);
        } // Ende else
      } // Ende if
    else {
      System.out.print("\nWer soll beginnen " +
                         "(1) Mensch oder (2) Computer? ");
      try 
        {ziffer = eing.readLine().toLowerCase().charAt(0);}
      catch(IOException e){}
      if (ziffer == '1') {
        anziehender = new Mensch(); 
        nachziehender = new Computer();
        } // Ende if
      else {
        anziehender = new Computer();
        nachziehender = new Mensch();
        } // Ende else
      } // Ende else
    } // Ende Startangaben
  
  void Zugfolge (Spielposition anfang) {
    Spieler amZug = anziehender;
    Spielposition position = anfang;
    while (! position.Ende()) {
      position.Darstellung();
      amZug.Aufforderung();
      Spielzug zug = amZug.zieht(position);
      position = zug.ausgefhrt();
      amZug = Gegner(amZug);
      } // Ende while
    endposition = position;
    endziehender = Gegner(amZug);
    } // Ende Zugfolge

  Spieler Gegner (Spieler sp) {
    if (sp == anziehender)
      return nachziehender; 
    else 
      return anziehender;
    } // Ende Gegner

  void Endinformation() {
    // Misre-Form des Spiels
    endposition.Darstellung();
    Spieler gewinner = Gegner(endziehender);
    gewinner.Endmeldung();
    } // Ende Endinformation

  protected boolean Schluss() { 
    char antwort = ' ';
    System.out.print("\nNoch eine Partie ?(j/n) ");
    try       
      {antwort = eing.readLine().toLowerCase().charAt(0);}
    catch(IOException e){}
    return antwort != 'j';
    } // Ende Schluss

  protected void Verabschiedung() {
    System.out.println("\nEs war schoen, mit Ihnen zu spielen.");
    System.out.println("Auf Wiedersehen.");
    } // Ende Verabschiedung

  } // Ende Spiel

