import java.io.*;

public abstract class Spieler {
  
  abstract void Aufforderung();

  abstract Spielzug zieht (Spielposition p);

  abstract void Endmeldung();
      
  } // Ende Spieler

class Mensch extends Spieler {
  // der menschliche Gegenspieler des Computers

  public void Aufforderung() 
    {System.out.println("Sie sind am Zug!");}

  public Spielzug zieht (Spielposition p) {
    Spielzug zug = new Spielzug(Eingabe(), p);
    while (! zug.zulssig()) {
      System.out.println("Ungueltiger Zug - neue Eingabe!");
      zug = new Spielzug(Eingabe(), p);
      } // Ende while
    return zug;
    } // Ende zieht

  private int Eingabe() {
    InputStreamReader lies = new InputStreamReader(System.in);
    BufferedReader    eing = new BufferedReader(lies);
    
    int anzahl = 0;
    try {
      System.out.print("Wie viele Hoelzchen nehmen Sie? ");
      anzahl = Integer.parseInt(eing.readLine());
      } // Ende try
    catch(IOException e){}
    return anzahl;
    } // Ende Eingabe

  public void Endmeldung()
    {System.out.println("\nGlueckwunsch - Sie haben gewonnen!");}

  } // Ende Mensch

class Person extends Mensch {

  private String name;

  public Person (String n)
    {name = n;}

  public void Aufforderung()
    {System.out.println(name + " ist am Zug!");}

  public void Endmeldung()
    {System.out.println(name + " hat gewonnen!");}

  } // Ende Person

class Computer extends Spieler {

  public void Aufforderung() 
    {System.out.print("Ich bin am Zug ");}

  public Spielzug zieht (Spielposition p) {
    Spielzug zug = Strategie(p);
    Zugmeldung(zug);
    return zug;
    } // Ende zieht

  private Spielzug Strategie (Spielposition p) {
    // ordnet jeder Spielposition einen Spielzug zu
    int[] zge = {0, 1,  1,  1,  1,  2,  
                     1,  1,  2,  3,  4,  5,
                     1,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10,
                    11,  1,  1,  2,  3,  4,  5,  6,  7,  8,  9, 
                    10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20};
    return new Spielzug(zge[p.Hlzchenzahl()], p);
    } // Ende Strategie

  public void Zugmeldung (Spielzug z) {
    System.out.println("... und nehme " + 
                        z.Entnahmezahl() + " Hoelzchen!");
    } // Zugmeldung

  public void Endmeldung()
    {System.out.println("\nSie haben leider verloren.");}

  } // Ende Computer
